Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Text
Imports System.Windows.Forms
Imports Syncfusion.Windows.Forms.Grid
Imports System.Collections.Specialized
Imports Syncfusion.Windows.Forms.Grid.Grouping
Imports Syncfusion.Grouping
Imports System.Threading
Imports System.Xml
Imports System.IO

Namespace GGC_Grouping_Table
	Partial Public Class Form1
		Inherits Form
		Public Sub New()
			InitializeComponent()
		End Sub

		Private mTable As DataTable
		Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
			mTable = GetTableDetails()
			Me.gridGroupingControl1.BeginUpdate()
			Me.gridGroupingControl1.DataSource = mTable
			Me.gridGroupingControl1.EndUpdate(True)
            Me.gridGroupingControl1.ShowGroupDropArea = True

            Me.gridGroupingControl1.TableDescriptor.VisibleColumns.Clear()
            Me.gridGroupingControl1.TableDescriptor.VisibleColumns.Add("Ship")
            Me.gridGroupingControl1.TableDescriptor.VisibleColumns.Add("Ship Amount")
            Me.gridGroupingControl1.TableDescriptor.VisibleColumns.Add("Shipping City")
            Me.gridGroupingControl1.TableDescriptor.VisibleColumns.Add("Rate")

			Me.gridGroupingControl1.TopLevelGroupOptions.ShowFilterBar = True
			For Each col As GridColumnDescriptor In Me.gridGroupingControl1.TableDescriptor.Columns
				col.AllowFilter = True
            Next col
            AddHandler gridGroupingControl1.TableModel.ClipboardCanPaste, AddressOf TableModel_ClipboardCanPaste
        End Sub

        Private Sub TableModel_ClipboardCanPaste(ByVal sender As Object, ByVal e As GridCutPasteEventArgs)
            Dim obj As DataObject = CType(Clipboard.GetDataObject(), DataObject)
            Dim flag As Boolean = False
            Dim lis As GridRangeInfoList
            Me.gridGroupingControl1.TableModel.Selections.GetSelectedRanges(lis, True)
            If lis.ActiveRange.Left = 2 Then
                If Not obj Is Nothing Then
                    Dim s As String = CType(obj.GetData(DataFormats.Text), String)
                    Dim norow As Integer = 0
                    Dim nocol As Integer = 0
                    Dim row As Integer = Me.gridGroupingControl1.TableControl.CurrentCell.RowIndex
                    Dim col As Integer = Me.gridGroupingControl1.TableControl.CurrentCell.ColIndex
                    For Each ch As String In s.Split(New String() {Constants.vbCrLf}, StringSplitOptions.RemoveEmptyEntries)
                        flag = True
                        norow += 1
                        If norow <= 2 Then
                            For Each cols As String In ch.Split(New Char() {ControlChars.Tab})
                                nocol += 1
                                If nocol < 3 Then
                                    Me.gridGroupingControl1.TableModel(row, col).Text = cols
                                    col += 1
                                End If
                            Next cols
                            col = Me.gridGroupingControl1.TableControl.CurrentCell.ColIndex
                            nocol = 0
                        End If
                        row += 1
                    Next ch
                    If flag Then
                        e.Handled = True
                        e.Result = False
                        flag = False
                    End If
                End If
            Else
                e.Handled = True
                e.Result = False
            End If
        End Sub

        Private Function GetTableDetails() As DataTable
            Dim dt As New DataTable("Details")
            Dim nRows As Integer = 100
            dt.Columns.Add(New DataColumn(String.Format("Ship")))
            dt.Columns.Add(New DataColumn(String.Format("Shipping City")))
            dt.Columns.Add(New DataColumn(String.Format("Ship Amount")))
            dt.Columns.Add(New DataColumn(String.Format("Rate")))

            Dim r As New Random()
            For i As Integer = 0 To nRows - 1
                Dim dr As DataRow = dt.NewRow()
                dr(0) = "Ship" & r.Next(100)
                If i Mod 20 < 5 Then
                    dr(1) = "A"
                    dr(2) = r.Next(5)
                ElseIf i Mod 20 >= 5 AndAlso i Mod 20 < 10 Then
                    dr(1) = "B"
                    dr(2) = r.Next(21, 30)
                ElseIf i Mod 20 >= 10 AndAlso i Mod 20 < 15 Then
                    dr(1) = "C"
                    dr(2) = r.Next(5)
                Else
                    dr(1) = "D"
                    dr(2) = r.Next(21, 30)
                End If
                dr(3) = r.Next(100)
                dt.Rows.Add(dr)
            Next i
            Return dt
        End Function

    End Class
End Namespace